unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CLkU, CLKConst, ComCtrls, Buttons;

type
  TfrmMain = class(TForm)
    pcCryptography: TPageControl;
    tsCheckLock: TTabSheet;
    tsCryptography: TTabSheet;
    btTestLock: TButton;
    btShowRegInfo: TButton;
    btTestLock_RegBased: TButton;
    btShowRegInfo_RegBased: TButton;
    btTestLock_IniBased: TButton;
    btShowRegInfo_IniBased: TButton;
    laText: TLabel;
    edText: TEdit;
    cbEncryptionMethod: TComboBox;
    laEncryptionMethod: TLabel;
    edEncodedText: TEdit;
    btEncode: TButton;
    laEncodedText: TLabel;
    laPassword: TLabel;
    edPassword: TEdit;
    laOriginalText: TLabel;
    edOriginalText: TEdit;
    tsMD5: TTabSheet;
    edMD5File: TEdit;
    btGetMD5File: TSpeedButton;
    odMD5File: TOpenDialog;
    edMD5: TEdit;
    btMD5: TButton;
    laMD5: TLabel;
    laFile: TLabel;
    laTextMD5: TLabel;
    laMD5Text: TLabel;
    edMD5Text: TEdit;
    edTextMD5: TEdit;
    btTextMD5: TButton;
    procedure btTestLockClick(Sender: TObject);
    procedure btShowRegInfoClick(Sender: TObject);
    procedure btTestLock_RegBasedClick(Sender: TObject);
    procedure btShowRegInfo_RegBasedClick(Sender: TObject);
    procedure btTestLock_IniBasedClick(Sender: TObject);
    procedure btShowRegInfo_IniBasedClick(Sender: TObject);
    procedure btEncodeClick(Sender: TObject);
    procedure pcCryptographyChange(Sender: TObject);
    procedure btGetMD5FileClick(Sender: TObject);
    procedure btMD5Click(Sender: TObject);
    procedure btTextMD5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.btTestLockClick(Sender: TObject);
var
  R : Integer;
const
  SuccessfulConstant = 3964;
begin
  //function cCheckLock(AppName, ParamFile, ParamEncPass : PAnsiChar; ParamEncMethod : Integer; HardwareIDMethod : Integer) : Integer; stdcall;
  //ParamEncMethod: 0..7, Default: 2
  //HardwareIDMethod: 0..2, 0: Hard Disk; 1: MainBoard; 2: Both
  //Note: This function stores Activation Code in an IniFile with name of protected executable file (CoLockTest.ini).
  R := cCheckLock('CoLockTest', 'CoLockTest.clk', '87654321', 2, 1);
  if R <> SuccessfulConstant then
    ShowMessage('Registration failed!')
  else
    ShowMessage('Program is registered.');
end;

procedure TfrmMain.btShowRegInfoClick(Sender: TObject);
begin
  //Displays user's registration information
  //Note: This function normally reads Activation Code from an IniFile with name of protected executable file (CoLockTest.ini).
  ShowLockWindow('CoLockTest', 'CoLockTest.clk', '87654321', 2, 'Please save your Activation Code for later usages.', 1);
end;

procedure TfrmMain.btTestLock_RegBasedClick(Sender: TObject);
var
  R : Integer;
begin
  //function cCheckLockReg(AppName, ParamFile, ParamEncPass : PAnsiChar; ParamEncMethod : Integer; HardwareIDMethod : Integer; ACRegKey : PAnsiChar) : Integer; stdcall;
  //ACRegKey must start with one of these root keys:
  //HKEY_CLASSES_ROOT, HKEY_CURRENT_USER, HKEY_LOCAL_MACHINE, HKEY_USERS, HKEY_CURRENT_CONFIG else
  //HKEY_LOCAL_MACHINE will be used as default root key
  R := cCheckLockReg('CoLockTest', 'CoLockTest.clk', '87654321', 2, 1, 'HKEY_LOCAL_MACHINE\Software\CoLock\CoLockTest');
  if R <> Const_Successful then
    ShowMessage('Registration failed!')
  else
    ShowMessage('Program is registered.');
end;

procedure TfrmMain.btShowRegInfo_RegBasedClick(Sender: TObject);
var
  R : Integer;
begin
  //function ShowLockWindowReg(AppName, ParamFile, ParamEncPass : PAnsiChar; ParamEncMethod : Integer; OptionalMessage : PAnsiChar; HardwareIDMethod : Integer; ACRegKey : PAnsiChar) : Integer; stdcall;
  //ACRegKey must start with one of these root keys:
  //HKEY_CLASSES_ROOT, HKEY_CURRENT_USER, HKEY_LOCAL_MACHINE, HKEY_USERS, HKEY_CURRENT_CONFIG else
  //HKEY_LOCAL_MACHINE will be used as default root key
  ShowLockWindowReg('CoLockTest', 'CoLockTest.clk', '87654321', 2, 'Please save your Activation Code for later usages.', 1, 'HKEY_LOCAL_MACHINE\Software\CoLock\CoLockTest');
end;

procedure TfrmMain.btTestLock_IniBasedClick(Sender: TObject);
var
  R : Integer;
begin
  //function cCheckLockIni(AppName, ParamFile, ParamEncPass : PAnsiChar; ParamEncMethod : Integer;
  //                       HardwareIDMethod : Integer; ACIniMethod : Integer; ACIniDir : PAnsiChar;
  //                       ACIniFile : PAnsiChar) : Integer; stdcall;
  R := cCheckLockIni('CoLockTest', 'CoLockTest.clk', '87654321', 2, 1, Const_AppDir, '', 'CoLockTestIniFile.ini');
  if R <> Const_Successful then
    ShowMessage('Registration failed!')
  else
    ShowMessage('Program is registered.');
end;

procedure TfrmMain.btShowRegInfo_IniBasedClick(Sender: TObject);
begin
  //function ShowLockWindowIni(AppName, ParamFile, ParamEncPass : PAnsiChar; ParamEncMethod : Integer; OptionalMessage : PAnsiChar; HardwareIDMethod : Integer; ACIniMethod : Integer; ACIniDir : PAnsiChar; ACIniFile : PAnsiChar) : Integer; stdcall;
  ShowLockWindowIni('CoLockTest', 'CoLockTest.clk', '87654321', 2, 'Please save your Activation Code for later usages.', 1, Const_AppDir, '', 'CoLockTestIniFile.ini');
end;

procedure TfrmMain.btEncodeClick(Sender: TObject);
begin
  if (Trim(edText.Text) = '') or (Trim(edPassword.Text) = '') then
    begin
      ShowMessage('Password or Text can not be empty.');
      Exit;
    end;
  edEncodedText.Text := CodeText(PAnsiChar(edText.Text), PAnsiChar(edPassword.Text), cbEncryptionMethod.ItemIndex, True);
  edOriginalText.Text := CodeText(PAnsiChar(edEncodedText.Text), PAnsiChar(edPassword.Text), cbEncryptionMethod.ItemIndex, False);
end;

procedure TfrmMain.pcCryptographyChange(Sender: TObject);
begin
  if pcCryptography.ActivePage = tsCryptography then
   ActiveControl := edText;
end;

procedure TfrmMain.btGetMD5FileClick(Sender: TObject);
begin
  if odMD5File.Execute then
    edMD5File.Text := odMD5File.FileName;
end;

procedure TfrmMain.btMD5Click(Sender: TObject);
var
  S : string;
begin
  S := edMD5File.Text;
  if FileExists(S) then
    begin
      edMD5.Text := GetFileMD5(PAnsiChar(S));
    end;
end;

procedure TfrmMain.btTextMD5Click(Sender: TObject);
var
  S : string;
begin
  S := edMD5Text.Text;
  if Trim(S) <> '' then
    begin
      edTextMD5.Text := GetTextMD5(PAnsiChar(S));
    end;
end;

end.
